/////////////////////////////////////////////////////////////////////////////
// Spectrum.cpp
// Spectrum File implementation
// this file is part of chemIR - Chemsuite Project
///////////////////////////////////////////////////////////////////////////

#include "spectrum.h"
#include <math.h>
#include <stdlib.h>
#include <qmessagebox.h>
#include <qfiledialog.h>
#include <qstring.h>

Spectrum::Spectrum(QString AFile)
{
Valid = true;
Data = false;
minY = 0;
maxY = 0;
xValues = QStringList();
yValues = QStringList();
waveNumbers = QStringList();
transmitancia = QStringList();
Afname = AFile;
graph = new QPixmap(800, 600);
graph->fill();
}

Spectrum::~Spectrum()
{
if(f)
 fclose(f);
delete graph;
}

void Spectrum::ProcessSpectrum()
{
 float xStep, yStep, yTmp, xTmp, xAcumulo, xCorrect;
 unsigned int i, yResult, xActual;
 bool md;
 int *z;

 yStep = YLEN/100;
 md = false;
 for(i=0;i<yValues.count();i++)
  {

   yTmp = yValues[i].toFloat();
   yTmp = yTmp*yStep;

   if((floor(maxY) < 1) && (maxY != 0))
     yTmp = yTmp * 100;

   yResult = (unsigned int) floor(rint(ENDY -  yTmp));
   yValues[i] =  QString::number(yResult);
   }

  xStep = Npoints/XLEN;
  z = new int;
  xAcumulo = frexp(xStep, z);
  delete z;
  xStep = floor(xStep);
  xCorrect = 0;

 if(Npoints > 8000)
   xStep = 2;

 nPixelsX = rint(Npoints/xStep)+2;
 xTmp = 1;
 xActual = ENDX;
 for(i = 0;i<xValues.count();i++)
   {
     yTmp = xValues[i].toFloat();
     xTmp = xTmp + 1;
     xCorrect = xCorrect + xAcumulo;

     if(Npoints < 2000)
      if(xCorrect >= 1.8)
        {
         xTmp = xTmp - 3;
         xCorrect = 0;
        }

      if(xTmp >= xStep)
       {
        xActual = xActual - 1;
        xTmp = 1;
       }

      if((xActual <= 50) && !md)
        {
         lastx = waveNumbers[i-1].toFloat();
         md = true;
        }


      xValues[i] = QString::number((unsigned int) floor(xActual + 48));
         
   }
   
}

// Exporta arquivos

void  Spectrum::Export()
{
QString fn = QFileDialog::getSaveFileName(QString::null, 
                                          "X11 Bitmap (*.xpm)" );
 if(!fn.isEmpty())
   graph->save(fn, "XPM");
  

}

